Index: /anuga_core/documentation/requirements/alpha_shape_sw_requirements_spec.txt
===================================================================
--- /anuga_core/documentation/requirements/alpha_shape_sw_requirements_spec.txt	(revision 4981)
+++ /anuga_core/documentation/requirements/alpha_shape_sw_requirements_spec.txt	(revision 4981)
@@ -0,0 +1,54 @@
+Alpha Shapes Software Requirements Specification
+By Duncan Gray
+
+$Revision:$
+$Date:$
+
+INTRODUCTION
+
+The alpha shape is a generalization of the convex hull of a point
+set. For alpha = infinity, the alpha-shape is the convex hull of S. As
+alpha decreases, the alpha-shape shrinks and develops cavities, as
+soon as a sphere of radius sqrt( alpha) can be put inside. Finally,
+for alpha = 0, the alpha-shape is the set S itself. The construction
+of a boundary like this manually, by joining the dots is time
+consuming, especially for large problems involving tens of thousands
+of points.
+
+OVERALL DESCRIPTION 
+
+The software will mainly be used to determine a border around a set of
+points.  This is time consuming manually and is needed to define the
+boundary of a simulation.
+
+DEFINITIONS
+
+CONSTRAINTS
+
+C1 - It will be written in python (or have a python interface). 
+C2 - It will work as a stand-alone application and as a python module.
+
+REQUIREMENTS
+R1 - Input co-ordinate values for a list of points.
+
+R2 - Output a boundary/polygon that all the input points are
+within. [This could be a list of point indexes pairs] 
+
+R3 - Ability to find and apply the optimum alpha parameter.
+ [What is optimum?  Maybe the smallest alpha parameter the encompass
+ all points in the same polygon?]
+R3.1 - Optionally a specified alpha parameter is applied.
+
+R4 - Be able to handle large data sets ( eg 100,000 - 500,000 )
+
+
+DEVELOPMENT
+
+A recomended data structure are arrays in Numeric.
+The C program 'triangle' could be an option for mesh generation.
+A unit test harness will also be developed.  This should be based on
+the pyvolution unit test harnessess. 
+
+ISSUES
+
+What sort of repository? Subversion or CVS?  Hopefully subversion is ok.
Index: uga_core/source/anuga/alpha_shape/wiki/software_requirements_specification.txt
===================================================================
--- /anuga_core/source/anuga/alpha_shape/wiki/software_requirements_specification.txt	(revision 4980)
+++ 	(revision )
@@ -1,54 +1,0 @@
-Alpha Shapes Software Requirements Specification
-By Duncan Gray
-
-$Revision:$
-$Date:$
-
-INTRODUCTION
-
-The alpha shape is a generalization of the convex hull of a point
-set. For alpha = infinity, the alpha-shape is the convex hull of S. As
-alpha decreases, the alpha-shape shrinks and develops cavities, as
-soon as a sphere of radius sqrt( alpha) can be put inside. Finally,
-for alpha = 0, the alpha-shape is the set S itself. The construction
-of a boundary like this manually, by joining the dots is time
-consuming, especially for large problems involving tens of thousands
-of points.
-
-OVERALL DESCRIPTION 
-
-The software will mainly be used to determine a border around a set of
-points.  This is time consuming manually and is needed to define the
-boundary of a simulation.
-
-DEFINITIONS
-
-CONSTRAINTS
-
-C1 - It will be written in python (or have a python interface). 
-C2 - It will work as a stand-alone application and as a python module.
-
-REQUIREMENTS
-R1 - Input co-ordinate values for a list of points.
-
-R2 - Output a boundary/polygon that all the input points are
-within. [This could be a list of point indexes pairs] 
-
-R3 - Ability to find and apply the optimum alpha parameter.
- [What is optimum?  Maybe the smallest alpha parameter the encompass
- all points in the same polygon?]
-R3.1 - Optionally a specified alpha parameter is applied.
-
-R4 - Be able to handle large data sets ( eg 100,000 - 500,000 )
-
-
-DEVELOPMENT
-
-A recomended data structure are arrays in Numeric.
-The C program 'triangle' could be an option for mesh generation.
-A unit test harness will also be developed.  This should be based on
-the pyvolution unit test harnessess. 
-
-ISSUES
-
-What sort of repository? Subversion or CVS?  Hopefully subversion is ok.
Index: /anuga_core/source/anuga/fit_interpolate/statrun.tst.sh
===================================================================
--- /anuga_core/source/anuga/fit_interpolate/statrun.tst.sh	(revision 4981)
+++ /anuga_core/source/anuga/fit_interpolate/statrun.tst.sh	(revision 4981)
@@ -0,0 +1,155 @@
+# Statistics generator script.  A good overnight job.  Then use table.awk
+# to convert an output stats file into a timings table.
+
+# General polygon tests
+make clean
+export MAKEOPTS="-DTIMER -DRANDOM -DSORT"
+make
+
+# test all basic algorithms on random polygons
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW > Rr0.sts
+p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
+p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
+p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
+p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
+p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
+p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
+
+# grid and trapezoid tests at resolution 20
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 > Rr0R20.sts
+p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
+p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
+p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
+p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
+p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
+p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
+
+# grid and trapezoid tests at resolution 100
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 > Rr0R100.sts
+p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
+p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
+p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
+p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
+p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
+p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
+
+
+# test all basic algorithms on regular polygons
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW > Rr1.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
+
+# grid and trapezoid tests at resolution 20
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 > Rr1R20.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
+
+# grid and trapezoid tests at resolution 100
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 > Rr1R100.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
+
+# General polygons, but not sorting edges
+make clean
+export MAKEOPTS="-DTIMER -DRANDOM"
+make
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -PS > Rr0no_sort.sts
+p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
+p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
+p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
+p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
+p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
+p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
+
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -PS > Rr1no_sort.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
+
+
+# Convex polygon tests, best algorithms
+make clean
+export MAKEOPTS="-DTIMER -DRANDOM -DSORT -DCONVEX -DHYBRID"
+make
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -EICMP > Rr1convex_hy.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
+
+# random triangles (vs. regular triangles)
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -EICMP > Rr0convex_hy.sts
+
+
+# Convex polygon tests, best algorithms
+make clean
+export MAKEOPTS="-DTIMER -DRANDOM -DSORT -DCONVEX"
+make
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CP > Rr1convex.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
+
+# random triangles (vs. regular triangles)
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -EICMP > Rr0convex.sts
+
+
+# convex polygon tests, no randomizing, no sorting (slower)
+make clean
+export MAKEOPTS="-DTIMER -DCONVEX -DHYBRID"
+make
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -ECMP > Rr1convex_no_sort.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
+
+# random triangles (vs. regular triangles)
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -ECMP > Rr0convex_no_sort.sts
+
+
+# Winding Number tests
+make clean
+export MAKEOPTS="-DTIMER -DRANDOM -DSORT -DWINDING"
+make
+
+# random polygons
+p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -CW > Rr0winding.sts
+p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
+p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
+p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
+p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
+p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
+p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
+
+# regular polygons
+p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CW > Rr1winding.sts
+p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
+p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
+p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
+p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
+p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
+p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
+
Index: uga_core/source/anuga/fit_interpolate/statrun.tst.txt
===================================================================
--- /anuga_core/source/anuga/fit_interpolate/statrun.tst.txt	(revision 4980)
+++ 	(revision )
@@ -1,155 +1,0 @@
-# Statistics generator script.  A good overnight job.  Then use table.awk
-# to convert an output stats file into a timings table.
-
-# General polygon tests
-make clean
-export MAKEOPTS="-DTIMER -DRANDOM -DSORT"
-make
-
-# test all basic algorithms on random polygons
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW > Rr0.sts
-p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
-p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
-p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
-p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
-p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
-p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -ABCMPSW >> Rr0.sts
-
-# grid and trapezoid tests at resolution 20
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 > Rr0R20.sts
-p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
-p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
-p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
-p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
-p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
-p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 20 -b 20 >> Rr0R20.sts
-
-# grid and trapezoid tests at resolution 100
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 > Rr0R100.sts
-p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
-p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
-p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
-p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
-p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
-p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -CGT -g 100 -b 100 >> Rr0R100.sts
-
-
-# test all basic algorithms on regular polygons
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW > Rr1.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -ABCMPSW >> Rr1.sts
-
-# grid and trapezoid tests at resolution 20
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 > Rr1R20.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 20 -b 20 >> Rr1R20.sts
-
-# grid and trapezoid tests at resolution 100
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 > Rr1R100.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CGT -g 100 -b 100 >> Rr1R100.sts
-
-# General polygons, but not sorting edges
-make clean
-export MAKEOPTS="-DTIMER -DRANDOM"
-make
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -PS > Rr0no_sort.sts
-p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
-p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
-p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
-p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
-p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
-p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -PS >> Rr0no_sort.sts
-
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -PS > Rr1no_sort.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -PS >> Rr1no_sort.sts
-
-
-# Convex polygon tests, best algorithms
-make clean
-export MAKEOPTS="-DTIMER -DRANDOM -DSORT -DCONVEX -DHYBRID"
-make
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -EICMP > Rr1convex_hy.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -EICMP >> Rr1convex_hy.sts
-
-# random triangles (vs. regular triangles)
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -EICMP > Rr0convex_hy.sts
-
-
-# Convex polygon tests, best algorithms
-make clean
-export MAKEOPTS="-DTIMER -DRANDOM -DSORT -DCONVEX"
-make
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CP > Rr1convex.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CP >> Rr1convex.sts
-
-# random triangles (vs. regular triangles)
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -EICMP > Rr0convex.sts
-
-
-# convex polygon tests, no randomizing, no sorting (slower)
-make clean
-export MAKEOPTS="-DTIMER -DCONVEX -DHYBRID"
-make
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -ECMP > Rr1convex_no_sort.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -ECMP >> Rr1convex_no_sort.sts
-
-# random triangles (vs. regular triangles)
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -ECMP > Rr0convex_no_sort.sts
-
-
-# Winding Number tests
-make clean
-export MAKEOPTS="-DTIMER -DRANDOM -DSORT -DWINDING"
-make
-
-# random polygons
-p_test -v 3 -n 50 -i 50 -r 0 -p 1 -d -CW > Rr0winding.sts
-p_test -v 4 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
-p_test -v 10 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
-p_test -v 20 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
-p_test -v 50 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
-p_test -v 100 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
-p_test -v 1000 -n 50 -i 50 -r 0 -p 1 -d -CW >> Rr0winding.sts
-
-# regular polygons
-p_test -v 3 -n 50 -i 50 -r 1 -p 0 -d -CW > Rr1winding.sts
-p_test -v 4 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
-p_test -v 10 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
-p_test -v 20 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
-p_test -v 50 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
-p_test -v 100 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
-p_test -v 1000 -n 50 -i 50 -r 1 -p 0 -d -CW >> Rr1winding.sts
-