Index: /anuga_validation/okushiri_2005/Benchmark_2_Bathymetry.lic
===================================================================
--- /anuga_validation/okushiri_2005/Benchmark_2_Bathymetry.lic	(revision 5023)
+++ /anuga_validation/okushiri_2005/Benchmark_2_Bathymetry.lic	(revision 5023)
@@ -0,0 +1,19 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+<ga_license_file>
+  <metadata>
+    <author>Ole Nielsen</author>
+  </metadata>
+  
+  <datafile>
+    <filename>Benchmark_2_Bathymetry.txt</filename>
+    <checksum>-1310724450</checksum>
+    <publishable>Yes</publishable>
+    <accountable>Ole Nielsen</accountable>
+    <source>http://www.cee.cornell.edu/longwave</source>
+    <IP_owner>Central Research Institute for Electric Power Industry (CRIEPI) in Abiko, Japan</IP_owner>
+    <IP_info>This dataset was published as part of THE THIRD INTERNATIONAL WORKSHOP ON LONG-WAVE RUNUP MODELS held June 17-18 2004 at Wrigley Marine Science Center, Catalina Island, California. See Benchmark #2 on the website and the README.txt file in this directory.
+    </IP_info>
+  </datafile>
+
+</ga_license_file>
Index: /anuga_validation/okushiri_2005/Benchmark_2_input.lic
===================================================================
--- /anuga_validation/okushiri_2005/Benchmark_2_input.lic	(revision 5023)
+++ /anuga_validation/okushiri_2005/Benchmark_2_input.lic	(revision 5023)
@@ -0,0 +1,19 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+<ga_license_file>
+  <metadata>
+    <author>Ole Nielsen</author>
+  </metadata>
+  
+  <datafile>
+    <filename>Benchmark_2_input.txt</filename>
+    <checksum>1408559107</checksum>
+    <publishable>Yes</publishable>
+    <accountable>Ole Nielsen</accountable>
+    <source>http://www.cee.cornell.edu/longwave</source>
+    <IP_owner>Central Research Institute for Electric Power Industry (CRIEPI) in Abiko, Japan</IP_owner>
+    <IP_info>This dataset was published as part of THE THIRD INTERNATIONAL WORKSHOP ON LONG-WAVE RUNUP MODELS held June 17-18 2004 at Wrigley Marine Science Center, Catalina Island, California. See Benchmark #2 on the website and the README.txt file in this directory.
+    </IP_info>
+  </datafile>
+
+</ga_license_file>
Index: /anuga_validation/okushiri_2005/problem02.lic
===================================================================
--- /anuga_validation/okushiri_2005/problem02.lic	(revision 5023)
+++ /anuga_validation/okushiri_2005/problem02.lic	(revision 5023)
@@ -0,0 +1,19 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+<ga_license_file>
+  <metadata>
+    <author>Ole Nielsen</author>
+  </metadata>
+  
+  <datafile>
+    <filename>problem02.doc</filename>
+    <checksum>-1811884659</checksum>
+    <publishable>Yes</publishable>
+    <accountable>Ole Nielsen</accountable>
+    <source>http://www.cee.cornell.edu/longwave</source>
+    <IP_owner>Central Research Institute for Electric Power Industry (CRIEPI) in Abiko, Japan</IP_owner>
+    <IP_info>This dataset was published as part of THE THIRD INTERNATIONAL WORKSHOP ON LONG-WAVE RUNUP MODELS held June 17-18 2004 at Wrigley Marine Science Center, Catalina Island, California. See Benchmark #2 on the website and the README.txt file in this directory.
+    </IP_info>
+  </datafile>
+
+</ga_license_file>
Index: /anuga_validation/okushiri_2005/timings.lic
===================================================================
--- /anuga_validation/okushiri_2005/timings.lic	(revision 5023)
+++ /anuga_validation/okushiri_2005/timings.lic	(revision 5023)
@@ -0,0 +1,18 @@
+<?xml version="1.0" encoding="iso-8859-1"?>
+
+<ga_license_file>
+  <metadata>
+    <author>Ole Nielsen</author>
+  </metadata>
+  
+  <datafile>
+    <filename>timings.txt</filename>
+    <checksum>-1935951304</checksum>
+    <publishable>Yes</publishable>
+    <accountable>Ole Nielsen</accountable>
+    <source>Ole Nielsen</source>
+    <IP_owner>Geoscience Australia</IP_owner>
+    <IP_info>This dataset recorded timings of the ANUGA validation. </IP_info>
+  </datafile>
+
+</ga_license_file>